// third_party/blink/public/mojom/frame/frame.mojom-test-utils.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_FRAME_FRAME_MOJOM_TEST_UTILS_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_FRAME_FRAME_MOJOM_TEST_UTILS_H_

#include "third_party/blink/public/mojom/frame/frame.mojom.h"
#include "third_party/blink/public/common/common_export.h"


namespace blink {
namespace mojom {


class BLINK_COMMON_EXPORT LocalFrameHostInterceptorForTesting : public LocalFrameHost {
  virtual LocalFrameHost* GetForwardingInterface() = 0;
  void EnterFullscreen(::blink::mojom::FullscreenOptionsPtr options, EnterFullscreenCallback callback) override;
  void ExitFullscreen() override;
  void FullscreenStateChanged(bool is_fullscreen) override;
  void RegisterProtocolHandler(const std::string& scheme, const ::GURL& url, const ::base::string16& title, bool user_gesture) override;
  void UnregisterProtocolHandler(const std::string& scheme, const ::GURL& url, bool user_gesture) override;
  void DidDisplayInsecureContent() override;
  void DidContainInsecureFormAction() override;
  void DocumentAvailableInMainFrame(bool uses_temporary_zoom_level) override;
  void SetNeedsOcclusionTracking(bool needs_tracking) override;
  void SetVirtualKeyboardOverlayPolicy(bool vk_overlays_content) override;
  void VisibilityChanged(::blink::mojom::FrameVisibility visibility) override;
  void DidChangeThemeColor(const base::Optional<::SkColor>& theme_color) override;
  void DidChangeBackgroundColor(const ::SkColor& background_color) override;
  void DidFailLoadWithError(const ::GURL& url, int32_t error_code) override;
  void DidFocusFrame() override;
  void DidCallFocus() override;
  void DidAddContentSecurityPolicies(std::vector<::network::mojom::ContentSecurityPolicyPtr> policies) override;
  void EnforceInsecureRequestPolicy(::blink::mojom::InsecureRequestPolicy policy_bitmap) override;
  void EnforceInsecureNavigationsSet(const std::vector<uint32_t>& set) override;
  void DidChangeActiveSchedulerTrackedFeatures(uint64_t features_mask) override;
  void SuddenTerminationDisablerChanged(bool present, ::blink::mojom::SuddenTerminationDisablerType disabler_type) override;
  void HadStickyUserActivationBeforeNavigationChanged(bool has_gesture) override;
  void ScrollRectToVisibleInParentFrame(const ::gfx::Rect& rect_to_scroll, ::blink::mojom::ScrollIntoViewParamsPtr params) override;
  void BubbleLogicalScrollInParentFrame(::blink::mojom::ScrollDirection direction, ::ui::ScrollGranularity granularity) override;
  void DidAccessInitialDocument() override;
  void DidBlockNavigation(const ::GURL& blocked_url, const ::GURL& initiator_url, ::blink::mojom::NavigationBlockedReason reason) override;
  void DidChangeLoadProgress(double load_progress) override;
  void DidFinishLoad(const ::GURL& validated_url) override;
  void DispatchLoad() override;
  void GoToEntryAtOffset(int32_t offset, bool has_user_gesture) override;
  void RenderFallbackContentInParentProcess() override;
  void UpdateTitle(const base::Optional<::base::string16>& title, ::base::i18n::TextDirection title_direction) override;
  void UpdateUserActivationState(::blink::mojom::UserActivationUpdateType update_type, ::blink::mojom::UserActivationNotificationType notification_type) override;
  void HandleAccessibilityFindInPageResult(FindInPageResultAXParamsPtr params) override;
  void HandleAccessibilityFindInPageTermination() override;
  void DocumentOnLoadCompleted() override;
  void ForwardResourceTimingToParent(::blink::mojom::ResourceTimingInfoPtr timing) override;
  void DidFinishDocumentLoad() override;
  void RunModalAlertDialog(const ::base::string16& alert_message, RunModalAlertDialogCallback callback) override;
  void RunModalConfirmDialog(const ::base::string16& alert_message, RunModalConfirmDialogCallback callback) override;
  void RunModalPromptDialog(const ::base::string16& alert_message, const ::base::string16& default_value, RunModalPromptDialogCallback callback) override;
  void RunBeforeUnloadConfirm(bool is_reload, RunBeforeUnloadConfirmCallback callback) override;
  void UpdateFaviconURL(std::vector<::blink::mojom::FaviconURLPtr> favicon_urls) override;
  void DownloadURL(DownloadURLParamsPtr params) override;
  void FocusedElementChanged(bool is_editable_element, const ::gfx::Rect& bounds_in_frame_widget, ::blink::mojom::FocusType focus_type) override;
  void TextSelectionChanged(const ::base::string16& text, uint32_t offset, const ::gfx::Range& range, bool user_initiated) override;
  void ShowPopupMenu(::mojo::PendingRemote<::blink::mojom::PopupMenuClient> popup_client, const ::gfx::Rect& bounds, int32_t item_height, double font_size, int32_t selected_item, std::vector<::blink::mojom::MenuItemPtr> menu_items, bool right_aligned, bool allow_multiple_selection) override;
  void DidLoadResourceFromMemoryCache(const ::GURL& url, const std::string& http_method, const std::string& mime_type, ::network::mojom::RequestDestination request_destination) override;
  void DidChangeFrameOwnerProperties(const ::base::UnguessableToken& child_frame_token, ::blink::mojom::FrameOwnerPropertiesPtr frame_owner_properties) override;
  void DidChangeOpener(const base::Optional<::base::UnguessableToken>& opener_frame) override;
  void DidChangeFramePolicy(const ::base::UnguessableToken& child_frame_token, const ::blink::FramePolicy& frame_policy) override;
  void DidChangeCSPAttribute(const ::base::UnguessableToken& child_frame_token, ::network::mojom::ContentSecurityPolicyPtr parsed_csp_attribute) override;
  void CapturePaintPreviewOfSubframe(const ::gfx::Rect& clip_rect, const ::base::UnguessableToken& guid) override;
  void Detach() override;
};
class BLINK_COMMON_EXPORT LocalFrameHostAsyncWaiter {
 public:
  explicit LocalFrameHostAsyncWaiter(LocalFrameHost* proxy);
  ~LocalFrameHostAsyncWaiter();
  void EnterFullscreen(
      ::blink::mojom::FullscreenOptionsPtr options, bool* out_granted);
  void RunModalAlertDialog(
      const ::base::string16& alert_message);
  void RunModalConfirmDialog(
      const ::base::string16& alert_message, bool* out_success);
  void RunModalPromptDialog(
      const ::base::string16& alert_message, const ::base::string16& default_value, bool* out_success, ::base::string16* out_result);
  void RunBeforeUnloadConfirm(
      bool is_reload, bool* out_success);

 private:
  LocalFrameHost* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(LocalFrameHostAsyncWaiter);
};


class BLINK_COMMON_EXPORT LocalFrameInterceptorForTesting : public LocalFrame {
  virtual LocalFrame* GetForwardingInterface() = 0;
  void GetTextSurroundingSelection(uint32_t max_length, GetTextSurroundingSelectionCallback callback) override;
  void SendInterventionReport(const std::string& id, const std::string& message) override;
  void SetFrameOwnerProperties(::blink::mojom::FrameOwnerPropertiesPtr properties) override;
  void NotifyUserActivation(::blink::mojom::UserActivationNotificationType notification_type) override;
  void NotifyVirtualKeyboardOverlayRect(const ::gfx::Rect& keyboard_rect) override;
  void AddMessageToConsole(::blink::mojom::ConsoleMessageLevel level, const std::string& message, bool discard_duplicates) override;
  void AddInspectorIssue(::blink::mojom::InspectorIssueInfoPtr info) override;
  void CheckCompleted() override;
  void StopLoading() override;
  void Collapse(bool collapsed) override;
  void EnableViewSourceMode() override;
  void Focus() override;
  void ClearFocusedElement() override;
  void GetResourceSnapshotForWebBundle(::mojo::PendingReceiver<::data_decoder::mojom::ResourceSnapshotForWebBundle> receiver) override;
  void CopyImageAt(const ::gfx::Point& window_point) override;
  void SaveImageAt(const ::gfx::Point& window_point) override;
  void ReportBlinkFeatureUsage(const std::vector<::blink::mojom::WebFeature>& features) override;
  void RenderFallbackContent() override;
  void BeforeUnload(bool is_reload, BeforeUnloadCallback callback) override;
  void MediaPlayerActionAt(const ::gfx::Point& location, ::blink::mojom::MediaPlayerActionPtr action) override;
  void AdvanceFocusInFrame(::blink::mojom::FocusType focus_type, const base::Optional<::base::UnguessableToken>& source_frame_token) override;
  void AdvanceFocusInForm(::blink::mojom::FocusType focus_type) override;
  void ReportContentSecurityPolicyViolation(::network::mojom::CSPViolationPtr violation) override;
  void DidUpdateFramePolicy(const ::blink::FramePolicy& frame_policy) override;
  void OnScreensChange() override;
  void PostMessageEvent(const base::Optional<::base::UnguessableToken>& source_frame_token, const ::base::string16& source_origin, const ::base::string16& target_origin, ::blink::TransferableMessage message) override;
  void BindReportingObserver(::mojo::PendingReceiver<::blink::mojom::ReportingObserver> receiver) override;
  void UpdateOpener(const base::Optional<::base::UnguessableToken>& opener_frame_token) override;
  void GetSavableResourceLinks(GetSavableResourceLinksCallback callback) override;
};
class BLINK_COMMON_EXPORT LocalFrameAsyncWaiter {
 public:
  explicit LocalFrameAsyncWaiter(LocalFrame* proxy);
  ~LocalFrameAsyncWaiter();
  void GetTextSurroundingSelection(
      uint32_t max_length, ::base::string16* out_content, uint32_t* out_start_offset, uint32_t* out_end_offset);
  void BeforeUnload(
      bool is_reload, bool* out_proceed, ::base::TimeTicks* out_before_unload_start_time, ::base::TimeTicks* out_before_unload_end_time);
  void GetSavableResourceLinks(
      GetSavableResourceLinksReplyPtr* out_reply);

 private:
  LocalFrame* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(LocalFrameAsyncWaiter);
};


class BLINK_COMMON_EXPORT HighPriorityLocalFrameInterceptorForTesting : public HighPriorityLocalFrame {
  virtual HighPriorityLocalFrame* GetForwardingInterface() = 0;
  void DispatchBeforeUnload(bool is_reload, DispatchBeforeUnloadCallback callback) override;
};
class BLINK_COMMON_EXPORT HighPriorityLocalFrameAsyncWaiter {
 public:
  explicit HighPriorityLocalFrameAsyncWaiter(HighPriorityLocalFrame* proxy);
  ~HighPriorityLocalFrameAsyncWaiter();
  void DispatchBeforeUnload(
      bool is_reload, bool* out_proceed, ::base::TimeTicks* out_before_unload_start_time, ::base::TimeTicks* out_before_unload_end_time);

 private:
  HighPriorityLocalFrame* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(HighPriorityLocalFrameAsyncWaiter);
};


class BLINK_COMMON_EXPORT RemoteFrameHostInterceptorForTesting : public RemoteFrameHost {
  virtual RemoteFrameHost* GetForwardingInterface() = 0;
  void SetInheritedEffectiveTouchAction(::cc::TouchAction touch_action) override;
  void UpdateRenderThrottlingStatus(bool is_throttled, bool subtree_throttled) override;
  void VisibilityChanged(::blink::mojom::FrameVisibility visibility) override;
  void DidFocusFrame() override;
  void CheckCompleted() override;
  void CapturePaintPreviewOfCrossProcessSubframe(const ::gfx::Rect& clip_rect, const ::base::UnguessableToken& guid) override;
  void SetIsInert(bool inert) override;
  void DidChangeOpener(const base::Optional<::base::UnguessableToken>& opener_frame) override;
  void AdvanceFocus(::blink::mojom::FocusType focus_type, const ::base::UnguessableToken& source_frame_token) override;
  void RouteMessageEvent(const base::Optional<::base::UnguessableToken>& source_frame_token, const ::base::string16& source_origin, const ::base::string16& target_origin, ::blink::TransferableMessage message) override;
  void PrintCrossProcessSubframe(const ::gfx::Rect& frame_content_rect, int32_t document_cookie) override;
  void Detach() override;
};
class BLINK_COMMON_EXPORT RemoteFrameHostAsyncWaiter {
 public:
  explicit RemoteFrameHostAsyncWaiter(RemoteFrameHost* proxy);
  ~RemoteFrameHostAsyncWaiter();

 private:
  RemoteFrameHost* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(RemoteFrameHostAsyncWaiter);
};


class BLINK_COMMON_EXPORT RemoteFrameInterceptorForTesting : public RemoteFrame {
  virtual RemoteFrame* GetForwardingInterface() = 0;
  void WillEnterFullscreen(::blink::mojom::FullscreenOptionsPtr options) override;
  void AddReplicatedContentSecurityPolicies(std::vector<::network::mojom::ContentSecurityPolicyHeaderPtr> headers) override;
  void ResetReplicatedContentSecurityPolicy() override;
  void EnforceInsecureNavigationsSet(const std::vector<uint32_t>& set) override;
  void SetFrameOwnerProperties(::blink::mojom::FrameOwnerPropertiesPtr properties) override;
  void EnforceInsecureRequestPolicy(::blink::mojom::InsecureRequestPolicy policy) override;
  void SetReplicatedOrigin(const ::url::Origin& origin, bool is_potentially_trustworthy_unique_origin) override;
  void SetReplicatedAdFrameType(::blink::mojom::AdFrameType ad_frame_type) override;
  void SetReplicatedName(const std::string& name, const std::string& unique_name) override;
  void DispatchLoadEventForFrameOwner() override;
  void SetNeedsOcclusionTracking(bool needs_tracking) override;
  void Collapse(bool collapsed) override;
  void Focus() override;
  void SetHadStickyUserActivationBeforeNavigation(bool has_gesture) override;
  void BubbleLogicalScroll(::blink::mojom::ScrollDirection direction, ::ui::ScrollGranularity granularity) override;
  void UpdateUserActivationState(::blink::mojom::UserActivationUpdateType state_update_type, ::blink::mojom::UserActivationNotificationType notification_type) override;
  void SetEmbeddingToken(const ::base::UnguessableToken& embedding_token) override;
  void SetPageFocus(bool is_focused) override;
  void RenderFallbackContent() override;
  void AddResourceTimingFromChild(::blink::mojom::ResourceTimingInfoPtr timing) override;
  void ScrollRectToVisible(const ::gfx::Rect& rect, ::blink::mojom::ScrollIntoViewParamsPtr params) override;
  void DidStartLoading() override;
  void DidStopLoading() override;
  void IntrinsicSizingInfoOfChildChanged(::blink::mojom::IntrinsicSizingInfoPtr sizing_info) override;
  void DidSetFramePolicyHeaders(::network::mojom::WebSandboxFlags sandbox_flags, const std::vector<::blink::ParsedFeaturePolicyDeclaration>& parsed_feature_policy) override;
  void DidUpdateFramePolicy(const ::blink::FramePolicy& frame_policy) override;
  void UpdateOpener(const base::Optional<::base::UnguessableToken>& opener_frame_token) override;
};
class BLINK_COMMON_EXPORT RemoteFrameAsyncWaiter {
 public:
  explicit RemoteFrameAsyncWaiter(RemoteFrame* proxy);
  ~RemoteFrameAsyncWaiter();

 private:
  RemoteFrame* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(RemoteFrameAsyncWaiter);
};


class BLINK_COMMON_EXPORT LocalMainFrameInterceptorForTesting : public LocalMainFrame {
  virtual LocalMainFrame* GetForwardingInterface() = 0;
  void AnimateDoubleTapZoom(const ::gfx::Point& point, const ::gfx::Rect& rect) override;
  void SetScaleFactor(float scale) override;
  void ClosePage(ClosePageCallback callback) override;
  void PluginActionAt(const ::gfx::Point& location, PluginActionType action) override;
  void SetInitialFocus(bool reverse) override;
  void EnablePreferredSizeChangedMode() override;
  void ZoomToFindInPageRect(const ::gfx::Rect& rect_in_root_frame) override;
  void InstallCoopAccessMonitor(::network::mojom::CoopAccessReportType report_type, const ::base::UnguessableToken& accessed_window, ::mojo::PendingRemote<::network::mojom::CrossOriginOpenerPolicyReporter> reporter, bool endpoint_defined, const std::string& reported_window_url) override;
  void OnPortalActivated(const ::blink::PortalToken& portal_token, ::mojo::PendingAssociatedRemote<::blink::mojom::Portal> portal, ::mojo::PendingAssociatedReceiver<::blink::mojom::PortalClient> portal_client, ::blink::TransferableMessage data, OnPortalActivatedCallback callback) override;
  void ForwardMessageFromHost(::blink::TransferableMessage message, const ::url::Origin& source_origin) override;
};
class BLINK_COMMON_EXPORT LocalMainFrameAsyncWaiter {
 public:
  explicit LocalMainFrameAsyncWaiter(LocalMainFrame* proxy);
  ~LocalMainFrameAsyncWaiter();
  void ClosePage(
      );
  void OnPortalActivated(
      const ::blink::PortalToken& portal_token, ::mojo::PendingAssociatedRemote<::blink::mojom::Portal> portal, ::mojo::PendingAssociatedReceiver<::blink::mojom::PortalClient> portal_client, ::blink::TransferableMessage data, ::blink::mojom::PortalActivateResult* out_result);

 private:
  LocalMainFrame* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(LocalMainFrameAsyncWaiter);
};


class BLINK_COMMON_EXPORT RemoteMainFrameInterceptorForTesting : public RemoteMainFrame {
  virtual RemoteMainFrame* GetForwardingInterface() = 0;
  void UpdateTextAutosizerPageInfo(TextAutosizerPageInfoPtr page_info) override;
};
class BLINK_COMMON_EXPORT RemoteMainFrameAsyncWaiter {
 public:
  explicit RemoteMainFrameAsyncWaiter(RemoteMainFrame* proxy);
  ~RemoteMainFrameAsyncWaiter();

 private:
  RemoteMainFrame* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(RemoteMainFrameAsyncWaiter);
};


class BLINK_COMMON_EXPORT LocalMainFrameHostInterceptorForTesting : public LocalMainFrameHost {
  virtual LocalMainFrameHost* GetForwardingInterface() = 0;
  void ScaleFactorChanged(float scale) override;
  void ContentsPreferredSizeChanged(const ::gfx::Size& pref_size) override;
  void TextAutosizerPageInfoChanged(TextAutosizerPageInfoPtr page_info) override;
  void FocusPage() override;
  void UpdateTargetURL(const ::GURL& url, UpdateTargetURLCallback callback) override;
};
class BLINK_COMMON_EXPORT LocalMainFrameHostAsyncWaiter {
 public:
  explicit LocalMainFrameHostAsyncWaiter(LocalMainFrameHost* proxy);
  ~LocalMainFrameHostAsyncWaiter();
  void UpdateTargetURL(
      const ::GURL& url);

 private:
  LocalMainFrameHost* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(LocalMainFrameHostAsyncWaiter);
};


class BLINK_COMMON_EXPORT RemoteMainFrameHostInterceptorForTesting : public RemoteMainFrameHost {
  virtual RemoteMainFrameHost* GetForwardingInterface() = 0;
  void FocusPage() override;
  void UpdateTargetURL(const ::GURL& url, UpdateTargetURLCallback callback) override;
  void RouteCloseEvent() override;
};
class BLINK_COMMON_EXPORT RemoteMainFrameHostAsyncWaiter {
 public:
  explicit RemoteMainFrameHostAsyncWaiter(RemoteMainFrameHost* proxy);
  ~RemoteMainFrameHostAsyncWaiter();
  void UpdateTargetURL(
      const ::GURL& url);

 private:
  RemoteMainFrameHost* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(RemoteMainFrameHostAsyncWaiter);
};




}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_FRAME_FRAME_MOJOM_TEST_UTILS_H_